// CH9344GPIODlg.cpp : implementation file
//

#include "stdafx.h"
#include "CH9344GPIO.h"
#include "CH9344GPIODlg.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "CH934XGPIO.h"
#pragma comment(lib,"CH934XGPIO")


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
BOOL bPortOpen;
INT  gPort;
BOOL gRS485 = FALSE;
BOOL gGPIO[4] = {FALSE,FALSE,FALSE,FALSE};
HANDLE gHPort;
ULONG mStrToHEX(const char * str) 
{  
	char mlen,i=0;
	UCHAR iChar=0,Char[9]="";
	UINT mBCD=0,de=1;
	mlen=strlen(str);
	memcpy(Char,str,mlen);
	for(i=mlen-1;i>=0;i--)
	{	
		iChar=Char[i];
		if ( iChar >= '0' && iChar <= '9' )
			mBCD = mBCD+(iChar -'0')*de;
		else if ( iChar >= 'A' && iChar <= 'F' ) 
			mBCD =mBCD+ (iChar - 'A' + 0x0a)*de;
		else if ( iChar >= 'a' && iChar <= 'f' )
			mBCD =mBCD+ (iChar - 'a' + 0x0a)*de;
		else return(0);
		de*=16;
	}
	return(mBCD);
}
BOOL CheckISCH9344(ULONG ComNum)
{
	CHAR PortName[64] = "";
	//CHAR cmd[MAX_PATH],parm[MAX_PATH];
	USHORT Data;
	BOOL result = FALSE;



	sprintf(PortName,"\\\\\.\\COM%d",ComNum);

	gHPort = CreateFile( PortName, GENERIC_READ | GENERIC_WRITE,  // 豸,֧ص
		FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );  // 
	if( gHPort == INVALID_HANDLE_VALUE )
	{
		//ShowLastError("Open %s:",PortName);
		return result;
	}
	
	if(CH934XGetChipVer(gHPort,&Data))
	{
		result = TRUE;
	}
	CloseHandle(gHPort);

	gHPort = INVALID_HANDLE_VALUE;
	return result;
}
int uart_open(ULONG ComNum,DWORD BaudRate,BOOL bFlow)
{

	CHAR PortName[64] = "";
	//CHAR cmd[MAX_PATH],parm[MAX_PATH];
	
	DCB dcb;
	COMMTIMEOUTS TimeOuts = {0};
	//UCHAR RxBuf[1024];
	//ULONG RxLen,RxedLen,TotalRx,TotalRxI;
	CHAR FmtStr[1024] = "";
	//ULONG TotalTestCount,TestC;



	sprintf(PortName,"\\\\\.\\COM%d",ComNum);

	gHPort = CreateFile( PortName, GENERIC_READ | GENERIC_WRITE,  // 豸,֧ص
		FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );  // 
	if( gHPort == INVALID_HANDLE_VALUE )
	{
		//ShowLastError("Open %s:",PortName);
		return -1;
	}
	//DbgPrint("Open %s succ,begin test",PortName);
	GetCommState(gHPort,&dcb);	
	//dcb.BaudRate = CBR_38400;
	dcb.BaudRate = BaudRate;
	//DbgPrint("BaudRate=%d",dcb.BaudRate);
	
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;
	dcb.XonLim  = 0;
	dcb.XoffLim  = 0;
	dcb.XonChar = 0;
	dcb.XoffChar = 0;
	dcb.ErrorChar = 0;
	dcb.EofChar = 0;
	dcb.EvtChar = 0;
	if(bFlow)
	{
		dcb.fOutxCtsFlow = TRUE;
		dcb.fRtsControl = RTS_CONTROL_HANDSHAKE;
	}else{
		dcb.fOutxCtsFlow = FALSE;
		dcb.fRtsControl = RTS_CONTROL_ENABLE;
	}
	
	SetCommState(gHPort,&dcb);

	//趨ʱ
	TimeOuts.ReadIntervalTimeout = -1;
	TimeOuts.ReadTotalTimeoutMultiplier=0;
	TimeOuts.ReadTotalTimeoutConstant=0;
	TimeOuts.WriteTotalTimeoutMultiplier=50;
	TimeOuts.WriteTotalTimeoutConstant=1000;
	SetCommTimeouts(gHPort,&TimeOuts);//óʱ

	//EscapeCommFunction(gHPort,SETRTS);
	EscapeCommFunction(gHPort,SETDTR);

	PurgeComm(gHPort,PURGE_RXCLEAR|PURGE_TXCLEAR|PURGE_TXABORT|PURGE_RXABORT);

	ClearCommBreak(gHPort);
	SetCommMask(gHPort,0);
	return 0;
}

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCH9344GPIODlg dialog

CCH9344GPIODlg::CCH9344GPIODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCH9344GPIODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCH9344GPIODlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCH9344GPIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCH9344GPIODlg)
	DDX_Control(pDX, IDC_COMBO_FLOW, m_ctrlFlow);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_ctrlBaud);
	DDX_Control(pDX, IDC_COMBO_UARTINDEX, m_ctrlUartIndex);
	DDX_Control(pDX, IDC_COMBO_UART, m_ctrlCom);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCH9344GPIODlg, CDialog)
	//{{AFX_MSG_MAP(CCH9344GPIODlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_UART_REFRESH, OnButtonUartRefresh)
	ON_BN_CLICKED(IDC_BUTTON_UART_OPEN, OnButtonUartOpen)
	ON_BN_CLICKED(IDC_BUTTON_ENABLEGPIO, OnButtonEnablegpio)
	ON_BN_CLICKED(IDC_BUTTON_GET_MODE, OnButtonGetMode)
	ON_CBN_SELCHANGE(IDC_COMBO_UARTINDEX, OnSelchangeComboUartindex)
	ON_BN_CLICKED(IDC_RADIO_I0, OnRadioI0)
	ON_BN_CLICKED(IDC_RADIO_O0, OnRadioO0)
	ON_BN_CLICKED(IDC_RADIO_I1, OnRadioI1)
	ON_BN_CLICKED(IDC_RADIO_O1, OnRadioO1)
	ON_BN_CLICKED(IDC_RADIO_I2, OnRadioI2)
	ON_BN_CLICKED(IDC_RADIO_O2, OnRadioO2)
	ON_BN_CLICKED(IDC_CHECK_IO0, OnCheckIo0)
	ON_BN_CLICKED(IDC_CHECK_IO1, OnCheckIo1)
	ON_BN_CLICKED(IDC_CHECK_IO2, OnCheckIo2)
	ON_BN_CLICKED(IDC_BUTTON_GETPIN, OnButtonGetpin)
	ON_BN_CLICKED(IDC_BUTTON_RECV_FILE, OnButtonRecvFile)
	ON_BN_CLICKED(IDC_BUTTON_SEND_FILE, OnButtonSendFile)
	ON_BN_CLICKED(IDC_BUTTON_STOP_RECV, OnButtonStopRecv)
	ON_BN_CLICKED(IDC_BUTTON_STOP_SEND, OnButtonStopSend)
	ON_BN_CLICKED(IDC_BUTTON_GET_CHIP_VER, OnButtonGetChipVer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCH9344GPIODlg message handlers

BOOL CCH9344GPIODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	OnButtonUartRefresh();
	
	CString st;
	st.Format(_T("9600"));
	m_ctrlBaud.InsertString(0,st);
	st.Format(_T("19200"));
	m_ctrlBaud.InsertString(1,st);
	st.Format(_T("38400"));
	m_ctrlBaud.InsertString(2,st);
	st.Format(_T("57600"));
	m_ctrlBaud.InsertString(3,st);
	st.Format(_T("115200"));
	m_ctrlBaud.InsertString(4,st);
	
	m_ctrlBaud.SetCurSel(4);
	st.Format(_T(""));
	m_ctrlFlow.InsertString(0,st);
	st.Format(_T("RTS/CTS"));
	m_ctrlFlow.InsertString(1,st);
	m_ctrlFlow.SetCurSel(0);
	CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
	CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_I1);
	CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_I2);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCH9344GPIODlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCH9344GPIODlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCH9344GPIODlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCH9344GPIODlg::OnButtonUartRefresh() 
{
	// TODO: Add your control notification handler code here
	HKEY hKey;   
	if(bPortOpen )
	{
		//sio_close(gPort);
		bPortOpen = FALSE;
		gPort = 0;
		CWnd * pwnd;
		pwnd = GetDlgItem(IDC_BUTTON_UART_OPEN);
		pwnd ->SetWindowText("򿪴");
	}
	m_ctrlCom.ResetContent();
	m_ctrlUartIndex.ResetContent();
    if(ERROR_SUCCESS ==::RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Hardware\\DeviceMap\\SerialComm",NULL, KEY_READ, &hKey ))//򿪴עӦļֵ   
    {   
        int i=0,j=0;   
        TCHAR RegKeyName[128],SerialPortName[128];  
        DWORD dwLong,dwSize;   
        while(TRUE)   
        {   
            dwLong = dwSize=sizeof(RegKeyName);   
            if(ERROR_NO_MORE_ITEMS==::RegEnumValue(hKey,i,RegKeyName,&dwLong,NULL,NULL,(PUCHAR)SerialPortName, &dwSize))//öٴ   
            {  
                break;   
            }  
			CString st;
			st.Format("%s",SerialPortName);
			st = st.Right(st.GetLength()-3);
			int num = atoi(st); 
			if(CheckISCH9344(num))
			{
				m_ctrlCom.InsertString(j,SerialPortName); 
				st.Format("WCH USB-SERIAL Ch %c",j+'A');
				m_ctrlUartIndex.InsertString(j,st);
				j++;   
			}
			i++;
        }  
        if(m_ctrlCom.GetCount() !=0)   
        {   
			m_ctrlCom.SetCurSel(0);
			m_ctrlUartIndex.SetCurSel(0);
        }  
        RegCloseKey(hKey);   
    }  
    else  
    {  
        RegCloseKey(hKey);  
    }  
}

void CCH9344GPIODlg::OnButtonUartOpen() 
{
	// TODO: Add your control notification handler code here
	CWnd * pwnd;
	if(bPortOpen )
	{
		//sio_close(gPort);
		m_bStopSend = TRUE;
		m_bStopRead = TRUE;
		CloseHandle(gHPort);
		bPortOpen = FALSE;
		gPort = 0;
		pwnd = GetDlgItem(IDC_BUTTON_UART_OPEN);
		pwnd ->SetWindowText("򿪴");

	}else{
		int nUartIndex = m_ctrlUartIndex.GetCurSel();
		int nIndex = m_ctrlCom.GetCurSel();
		if(nIndex  != CB_ERR)
		{
			CString st;
			m_ctrlCom.GetLBText(nIndex,st);
			st = st.Right(st.GetLength()-3);
			gPort = atoi(st);
			DWORD BaudRate;
			BOOL bFlow;
			nIndex = m_ctrlBaud.GetCurSel();
			if(nIndex== 0 )
			{
				BaudRate = CBR_9600;
			}else if(nIndex== 1 )
			{
				BaudRate = CBR_19200;
			}else if(nIndex== 2 )
			{
				BaudRate = CBR_38400;
			}else if(nIndex== 3 )
			{
				BaudRate = CBR_57600;
			}else if(nIndex== 4 )
			{
				BaudRate = CBR_115200;
			}
			nIndex = m_ctrlFlow.GetCurSel();
			if(nIndex == 0)
			{
				bFlow = FALSE;
			}else {
				bFlow = TRUE;
			}
			if(uart_open(gPort,BaudRate,bFlow) == 0)
			{
				bPortOpen = TRUE;
				pwnd = GetDlgItem(IDC_BUTTON_UART_OPEN);
				pwnd ->SetWindowText("رմ");


				UCHAR mode,errCode;
				for(UINT i = 0 ; i < 3; i ++)
				{
					if( CH934XGetCurrentMode(gHPort,i,&mode,&errCode))
					{
						if(mode == 2) //GPIO
						{
							gGPIO[i] = TRUE;
							if(nUartIndex == i)
							{
								UCHAR dir;
								if( CH934XGetGPIODir(gHPort,i,&dir,&errCode) )
								{
									if(dir & 0x01)
									{
										CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_O0);
									}else{
										CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
									}

									if(dir & 0x02)
									{
										CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_O1);
									}else{
										CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_I1);
									}

									if(dir & 0x04)
									{
										CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_O2);
									}else{
										CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_I2);
									}
								}
							}

						}else 
						{
							gGPIO[i] = FALSE;
							if(nUartIndex == i)
							{
								CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
								CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_I1);
								CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_I2);
							}
						}
					}
				}

			}
	
			
		}else{
			//AfxMessageBox("");
		}
	}
}



void CCH9344GPIODlg::OnButtonEnablegpio() 
{
	// TODO: Add your control notification handler code here
	UCHAR errCode;
	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		return;
	}
	USHORT uartindex;
	if(!CH934XGetUartIndex(gHPort,&uartindex))
	{
		AfxMessageBox("CH934XGetUartIndex Error");
		return;
	}
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(!gGPIO[nIndex])
	{
		
		if(CH934XEnableGPIO(gHPort,nIndex,&errCode))
		{
			gGPIO[nIndex] = TRUE;
			SetDlgItemText(IDC_BUTTON_ENABLEGPIO,"ָͨģʽ");
			SetDlgItemText(IDC_EDIT_MODE,"GPIOģʽ");
			if(uartindex == nIndex )
			{
				SetDlgItemText(IDC_BUTTON_ENABLERS485,"ʹRS485");
			}
			UCHAR dir;
			if( CH934XGetGPIODir(gHPort,nIndex,&dir,&errCode) )
			{
				if(dir & 0x01)
				{
					CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_O0);
				}else{
					CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
				}

				if(dir & 0x02)
				{
					CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_O1);
				}else{
					CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_I1);
				}

				if(dir & 0x04)
				{
					CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_O2);
				}else{
					CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_I2);
				}
			}
		}
		
	}else{
		if(CH934XEnableNormal(gHPort,nIndex,&errCode))  
		{
			gGPIO[nIndex] = FALSE;
			SetDlgItemText(IDC_BUTTON_ENABLEGPIO,"ʹGPIO");
			SetDlgItemText(IDC_EDIT_MODE,"ͨģʽ");
			
			if(uartindex == nIndex )
			{
				SetDlgItemText(IDC_BUTTON_ENABLERS485,"ʹRS485");
			}
			CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
			CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_I1);
			CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_I2);
		}
	}
}

void CCH9344GPIODlg::OnButtonGetMode() 
{
	// TODO: Add your control notification handler code here
	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		return;
	}
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(nIndex  != CB_ERR)
	{
		UCHAR mode,errCode;
		if( CH934XGetCurrentMode(gHPort,nIndex,&mode,&errCode))
		{
			CString st;
			if(mode == 0)
			{
				st = "ͨģʽ";
			}else if(mode == 1)
			{
				st = "RS485ģʽ";
			}else if(mode == 2)
			{
				st = "GPIOģʽ";
			}else if(mode == 3)
			{
				st = "Ӳ";
			}
			SetDlgItemText(IDC_EDIT_MODE,st);
		}
	}
}

void CCH9344GPIODlg::OnSelchangeComboUartindex() 
{
	// TODO: Add your control notification handler code here
	if(!bPortOpen )
	{
		//AfxMessageBox("ȴ򿪴");
		return;
	}
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(nIndex  != CB_ERR)
	{
		UCHAR mode,errCode;
		if( CH934XGetCurrentMode(gHPort,nIndex,&mode,&errCode))
		{
			CString st;
			if(mode == 0)
			{
				st = "ͨģʽ";
			}else if(mode == 1)
			{
				st = "RS485ģʽ";
			}else if(mode == 2)
			{
				st = "GPIOģʽ";
			}else if(mode == 3)
			{
				st = "Ӳ";
			}
			SetDlgItemText(IDC_EDIT_MODE,st);
			
		}

		USHORT uartindex;
		CWnd * pwnd;
		uartindex = nIndex;
		if(!gGPIO[uartindex])
		{
			pwnd = GetDlgItem(IDC_BUTTON_ENABLEGPIO);
			pwnd ->SetWindowText("ʹGPIO");
			CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
			CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_I1);
			CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_I2);
		}else{
			if(mode == 2)
			{
				pwnd = GetDlgItem(IDC_BUTTON_ENABLEGPIO);
				pwnd ->SetWindowText("ָͨģʽ");	


				UCHAR dir;
				if( CH934XGetGPIODir(gHPort,uartindex,&dir,&errCode) )
				{
					if(dir & 0x01)
					{
						CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_O0);
					}else{
						CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
					}

					if(dir & 0x02)
					{
						CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_O1);
					}else{
						CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_I1);
					}

					if(dir & 0x04)
					{
						CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_O2);
					}else{
						CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_I2);
					}
				}

			}else{
				gGPIO[uartindex] = FALSE;
				pwnd = GetDlgItem(IDC_BUTTON_ENABLEGPIO);
				pwnd ->SetWindowText("ʹGPIO");
				CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
				CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_I1);
				CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_I2);
			}
		}
	}
	

	
}

void CCH9344GPIODlg::OnRadioI0() 
{
	// TODO: Add your control notification handler code here

	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
		return;
	}
	UCHAR GPIOIndex = 0;
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(nIndex  != CB_ERR)
	{
		UCHAR mode,errCode;
		if( CH934XGetCurrentMode(gHPort,nIndex,&mode,&errCode))
		{
			CString st;
			if(mode == 2)
			{
				UCHAR dir=0;
				if( !CH934XSetGPIODir(gHPort,nIndex,GPIOIndex,dir,&errCode))
				{
					AfxMessageBox("ָڷȷ");
				}else{
					if( !CH934XGetGPIOInput(gHPort,nIndex,GPIOIndex,&dir,&errCode))
					{
						AfxMessageBox("ȡָGPIOֵȷ");
					}else{
						if( dir & 1 )
						{
							CheckDlgButton(IDC_CHECK_IO0,BST_CHECKED);
						}else{
							CheckDlgButton(IDC_CHECK_IO0,BST_UNCHECKED);
						}
					}
				}
				
			}else 
			{
				AfxMessageBox("ָģʽGPIOģʽ");
			}
		}
	}
	CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
	
}

void CCH9344GPIODlg::OnRadioO0() 
{
	// TODO: Add your control notification handler code here

	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_O0);
		return;
	}
	UCHAR GPIOIndex = 0;
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(nIndex  != CB_ERR)
	{
		UCHAR mode,errCode;
		if( CH934XGetCurrentMode(gHPort,nIndex,&mode,&errCode))
		{
			CString st;
			if(mode == 2)
			{
				UCHAR dir=1;
				if( !CH934XSetGPIODir(gHPort,nIndex,GPIOIndex,dir,&errCode))
				{
					AfxMessageBox("ָڷȷ");
				}
				
			}else 
			{
				AfxMessageBox("ָģʽGPIOģʽ");
			}
		}
	}

	CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_O0);
}

void CCH9344GPIODlg::OnRadioI1() 
{
	// TODO: Add your control notification handler code here

	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_I1);
		return;
	}
	UCHAR GPIOIndex = 1;
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(nIndex  != CB_ERR)
	{
		UCHAR mode,errCode;
		if( CH934XGetCurrentMode(gHPort,nIndex,&mode,&errCode))
		{
			CString st;
			if(mode == 2)
			{
				UCHAR dir=0;
				if( !CH934XSetGPIODir(gHPort,nIndex,GPIOIndex,dir,&errCode))
				{
					AfxMessageBox("ָڷȷ");
				}else{
					if( !CH934XGetGPIOInput(gHPort,nIndex,GPIOIndex,&dir,&errCode))
					{
						AfxMessageBox("ȡָGPIOֵȷ");
					}else{
						if( dir & 1 )
						{
							CheckDlgButton(IDC_CHECK_IO1,BST_CHECKED);
						}else{
							CheckDlgButton(IDC_CHECK_IO1,BST_UNCHECKED);
						}
					}
				}
				
			}else 
			{
				AfxMessageBox("ָģʽGPIOģʽ");
			}
		}
	}

	CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_I1);
}

void CCH9344GPIODlg::OnRadioO1() 
{
	// TODO: Add your control notification handler code here
	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_O1);
		return;
	}
	UCHAR GPIOIndex = 1;
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(nIndex  != CB_ERR)
	{
		UCHAR mode,errCode;
		if( CH934XGetCurrentMode(gHPort,nIndex,&mode,&errCode))
		{
			CString st;
			if(mode == 2)
			{
				UCHAR dir=1;
				if( !CH934XSetGPIODir(gHPort,nIndex,GPIOIndex,dir,&errCode))
				{
					AfxMessageBox("ָڷȷ");
				}
				
			}else 
			{
				AfxMessageBox("ָģʽGPIOģʽ");
			}
		}
	}
	CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_O1);
}

void CCH9344GPIODlg::OnRadioI2() 
{
	// TODO: Add your control notification handler code here
	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_I2);
		return;
	}
	UCHAR GPIOIndex = 2;
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(nIndex  != CB_ERR)
	{
		UCHAR mode,errCode;
		if( CH934XGetCurrentMode(gHPort,nIndex,&mode,&errCode))
		{
			CString st;
			if(mode == 2)
			{
				UCHAR dir=0;
				if( !CH934XSetGPIODir(gHPort,nIndex,GPIOIndex,dir,&errCode))
				{
					AfxMessageBox("ָڷȷ");
				}else{
					if( !CH934XGetGPIOInput(gHPort,nIndex,GPIOIndex,&dir,&errCode))
					{
						AfxMessageBox("ȡָGPIOֵȷ");
					}else{
						if( dir & 1 )
						{
							CheckDlgButton(IDC_CHECK_IO2,BST_CHECKED);
						}else{
							CheckDlgButton(IDC_CHECK_IO2,BST_UNCHECKED);
						}
					}
				}
				
			}else 
			{
				AfxMessageBox("ָģʽGPIOģʽ");
			}
		}
	}
	CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_I2);
}

void CCH9344GPIODlg::OnRadioO2() 
{
	// TODO: Add your control notification handler code here

	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_O2);
		return;
	}
	UCHAR GPIOIndex = 2;
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(nIndex  != CB_ERR)
	{
		UCHAR mode,errCode;
		if( CH934XGetCurrentMode(gHPort,nIndex,&mode,&errCode))
		{
			CString st;
			if(mode == 2)
			{
				UCHAR dir=1;
				if( !CH934XSetGPIODir(gHPort,nIndex,GPIOIndex,dir,&errCode))
				{
					AfxMessageBox("ָڷȷ");
				}
				
			}else 
			{
				AfxMessageBox("ָģʽGPIOģʽ");
			}
		}
	}

	CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_O2);
}

void CCH9344GPIODlg::OnCheckIo0() 
{
	// TODO: Add your control notification handler code here
	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		return;
	}
	UCHAR GPIOIndex = 0;
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(nIndex  != CB_ERR)
	{
		UCHAR mode,errCode;
		if( CH934XGetCurrentMode(gHPort,nIndex,&mode,&errCode))
		{
			CString st;
			if(mode == 2)
			{
				UCHAR dir;
				if( !CH934XGetGPIODir(gHPort,nIndex,&dir,&errCode))
				{
					AfxMessageBox("ָڷȷ");
				}else{
					if(dir&0x01)
					{
						if( IsDlgButtonChecked(IDC_CHECK_IO0) )
						{
							if( !CH934XSetGPIOOutput(gHPort,nIndex,GPIOIndex,1,&errCode) )
							{
								AfxMessageBox("ָGPIOֵȷ");
							}
						}else{
							if( !CH934XSetGPIOOutput(gHPort,nIndex,GPIOIndex,0,&errCode) )
							{
								AfxMessageBox("ָGPIOֵȷ");
							}
						}
					}else{
						if( IsDlgButtonChecked(IDC_CHECK_IO0) )
						{
							CheckDlgButton(IDC_CHECK_IO0,BST_UNCHECKED);
							
						}else{
							CheckDlgButton(IDC_CHECK_IO0,BST_CHECKED);
						}
						AfxMessageBox("ָGPIO");
					}
				}
				
			}else 
			{
				AfxMessageBox("ָģʽGPIOģʽ");
			}
		}
	}
}

void CCH9344GPIODlg::OnCheckIo1() 
{
	// TODO: Add your control notification handler code here
	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		return;
	}
	UCHAR GPIOIndex = 1;
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(nIndex  != CB_ERR)
	{
		UCHAR mode,errCode;
		if( CH934XGetCurrentMode(gHPort,nIndex,&mode,&errCode))
		{
			CString st;
			if(mode == 2)
			{
				UCHAR dir;
				if( !CH934XGetGPIODir(gHPort,nIndex,&dir,&errCode))
				{
					AfxMessageBox("ָڷȷ");
				}else{
					if(dir&0x02)
					{
						if( IsDlgButtonChecked(IDC_CHECK_IO1) )
						{
							if( !CH934XSetGPIOOutput(gHPort,nIndex,GPIOIndex,1,&errCode) )
							{
								AfxMessageBox("ָGPIOֵȷ");
							}
						}else{
							if( !CH934XSetGPIOOutput(gHPort,nIndex,GPIOIndex,0,&errCode) )
							{
								AfxMessageBox("ָGPIOֵȷ");
							}
						}
					}else{
						if( IsDlgButtonChecked(IDC_CHECK_IO1) )
						{
							CheckDlgButton(IDC_CHECK_IO1,BST_UNCHECKED);
							
						}else{
							CheckDlgButton(IDC_CHECK_IO1,BST_CHECKED);
						}
						AfxMessageBox("ָGPIO");
					}
				}
				
			}else 
			{
				AfxMessageBox("ָģʽGPIOģʽ");
			}
		}
	}
}

void CCH9344GPIODlg::OnCheckIo2() 
{
	// TODO: Add your control notification handler code here
	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		return;
	}
	UCHAR GPIOIndex = 2;
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(nIndex  != CB_ERR)
	{
		UCHAR mode,errCode;
		if( CH934XGetCurrentMode(gHPort,nIndex,&mode,&errCode))
		{
			CString st;
			if(mode == 2)
			{
				UCHAR dir;
				if( !CH934XGetGPIODir(gHPort,nIndex,&dir,&errCode))
				{
					AfxMessageBox("ָڷȷ");
				}else{
					if(dir&0x04)
					{
						if( IsDlgButtonChecked(IDC_CHECK_IO2) )
						{
							if( !CH934XSetGPIOOutput(gHPort,nIndex,GPIOIndex,1,&errCode) )
							{
								AfxMessageBox("ָGPIOֵȷ");
							}
						}else{
							if( !CH934XSetGPIOOutput(gHPort,nIndex,GPIOIndex,0,&errCode) )
							{
								AfxMessageBox("ָGPIOֵȷ");
							}
						}
					}else{
						if( IsDlgButtonChecked(IDC_CHECK_IO2) )
						{
							CheckDlgButton(IDC_CHECK_IO2,BST_UNCHECKED);
							
						}else{
							CheckDlgButton(IDC_CHECK_IO2,BST_CHECKED);
						}
						AfxMessageBox("ָGPIO");
					}
				}
				
			}else 
			{
				AfxMessageBox("ָģʽGPIOģʽ");
			}
		}
	}
}



void CCH9344GPIODlg::OnButtonGetpin() 
{
	// TODO: Add your control notification handler code here
	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
		return;
	}
	int nIndex = m_ctrlUartIndex.GetCurSel();
	if(nIndex  != CB_ERR)
	{
		for( UCHAR GPIOIndex = 0; GPIOIndex < 3; GPIOIndex ++)
		{
			UCHAR mode,errCode;
			if( CH934XGetCurrentMode(gHPort,nIndex,&mode,&errCode))
			{
				CString st;
				if(mode == 2)
				{
					UCHAR dir;
					if( !CH934XGetGPIODir(gHPort,nIndex,&dir,&errCode))
					{
						//AfxMessageBox("ָڷȷ");
					}else{
						if( !(dir & ( 1<<GPIOIndex)) )
						{

							if( !CH934XGetGPIOInput(gHPort,nIndex,GPIOIndex,&dir,&errCode))
							{
								AfxMessageBox("ȡָGPIOֵȷ");
							}else{
								if( dir & 1 )
								{
									CheckDlgButton(IDC_CHECK_IO0+GPIOIndex,BST_CHECKED);
								}else{
									CheckDlgButton(IDC_CHECK_IO0+GPIOIndex,BST_UNCHECKED);
								}
							}

						}else{

						}
					}
					
				}else 
				{
					//AfxMessageBox("ָģʽGPIOģʽ");
				}
			}
		}
	}
}

void CCH9344GPIODlg::OnButtonRecvFile() 
{
	// TODO: Add your control notification handler code here
	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		return;
	}
	m_bStopRead = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_RECV_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	AfxBeginThread(ThreadRecv,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
}

void CCH9344GPIODlg::OnButtonSendFile() 
{
	// TODO: Add your control notification handler code here
	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		return;
	}
	m_bStopSend = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SEND_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	
	TCHAR szFilters[]= _T("BIN Files (*.BIN)|*.BIN|All Files (*.*)|*.*||");
	TCHAR CurPathName[512];
	GetCurrentDirectory(sizeof(CurPathName),CurPathName);
	// Create an Open dialog; the default file name extension is ".my".
	CFileDialog fileDlg(TRUE, _T("BIN"), _T("*.BIN"),
	  OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilters);

	// Display the file dialog. When user clicks OK, fileDlg.DoModal() 
	// returns IDOK.
	if(fileDlg.DoModal() == IDOK)
	{
		m_strPathName = fileDlg.GetPathName();
		SetCurrentDirectory(CurPathName);
		//AfxMessageBox(m_strPathName);
		AfxBeginThread(ThreadSend,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
	}else ::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}

UINT CCH9344GPIODlg::ThreadRecv(LPVOID pParam)
{
	CCH9344GPIODlg * pThis;
	pThis = (CCH9344GPIODlg * )pParam;
	UCHAR buf[1024];
	ULONG len;
	CString stFileName = "data.bin";
	DeleteFile(stFileName);
	while(TRUE)
	{	
		if(pThis->m_bStopRead) break;

		len = sizeof(buf);
		memset(buf,0,sizeof(buf));
		if( ReadFile(gHPort, buf, len, &len, NULL) )
		{
			if(len != 0)
			{
				
				CStdioFile f;
				
				if(!f.Open(stFileName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
				{
					
				   break;
				}
				f.SeekToEnd();
			
				f.Write(buf,len);
				f.Close();
			}

		}
		Sleep(1);
	}

	CWnd * pwnd = pThis->GetDlgItem(IDC_BUTTON_RECV_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);

	return 0;
}

void CCH9344GPIODlg::OnButtonStopRecv() 
{
	// TODO: Add your control notification handler code here
	m_bStopRead = TRUE;
}

UINT CCH9344GPIODlg::ThreadSend(LPVOID pParam)
{
	CCH9344GPIODlg * pThis;
	pThis = (CCH9344GPIODlg * )pParam;
	UCHAR buf[256];
	ULONG len;
	CStdioFile f;
	if(!f.Open(pThis->m_strPathName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
	{
		CWnd * pwnd = pThis->GetDlgItem(IDC_BUTTON_SEND_FILE);
		::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	   return 0;
	}
	
	while(TRUE)
	{	
		if(pThis->m_bStopSend) break;
	

		len = f.Read(buf,sizeof(buf));
		if(len > 0)
		{
			if( ( WriteFile(gHPort, buf, len, &len, NULL)) )
			{
			}
		}else{
			break;
		}
	}
	f.Close();

	CWnd * pwnd = pThis->GetDlgItem(IDC_BUTTON_SEND_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

void CCH9344GPIODlg::OnButtonStopSend() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = TRUE;
}

void CCH9344GPIODlg::OnButtonGetChipVer() 
{
	// TODO: Add your control notification handler code here
	if(!bPortOpen )
	{
		AfxMessageBox("ȴ򿪴");
		return;
	}
	USHORT data;
	if( CH934XGetChipVer(gHPort,&data))
	{
		CString st;
		st.Format("%X",data);
		SetDlgItemText(IDC_EDIT_CHIP_VER,st);
	}
}
