// CH9344GPIODlg.h : header file
//

#if !defined(AFX_CH9344GPIODLG_H__127CD9A6_2D7C_4689_AD75_D3455DCBED9F__INCLUDED_)
#define AFX_CH9344GPIODLG_H__127CD9A6_2D7C_4689_AD75_D3455DCBED9F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "MyEdit.h"
/////////////////////////////////////////////////////////////////////////////
// CCH9344GPIODlg dialog

class CCH9344GPIODlg : public CDialog
{
// Construction
public:
	static UINT ThreadSend(LPVOID pParam);
	static UINT ThreadRecv(LPVOID pParam);
	CCH9344GPIODlg(CWnd* pParent = NULL);	// standard constructor
	BOOL  m_bStopRead;
	BOOL  m_bStopSend;
	CString m_strPathName;
// Dialog Data
	//{{AFX_DATA(CCH9344GPIODlg)
	enum { IDD = IDD_CH9344GPIO_DIALOG };
	CComboBox	m_ctrlFlow;
	CComboBox	m_ctrlBaud;
	CComboBox	m_ctrlUartIndex;
	CComboBox	m_ctrlCom;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCH9344GPIODlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CCH9344GPIODlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonUartRefresh();
	afx_msg void OnButtonUartOpen();
	afx_msg void OnButtonEnablegpio();
	afx_msg void OnButtonGetMode();
	afx_msg void OnSelchangeComboUartindex();
	afx_msg void OnRadioI0();
	afx_msg void OnRadioO0();
	afx_msg void OnRadioI1();
	afx_msg void OnRadioO1();
	afx_msg void OnRadioI2();
	afx_msg void OnRadioO2();
	afx_msg void OnCheckIo0();
	afx_msg void OnCheckIo1();
	afx_msg void OnCheckIo2();
	afx_msg void OnButtonGetpin();
	afx_msg void OnButtonRecvFile();
	afx_msg void OnButtonSendFile();
	afx_msg void OnButtonStopRecv();
	afx_msg void OnButtonStopSend();
	afx_msg void OnButtonGetChipVer();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CH9344GPIODLG_H__127CD9A6_2D7C_4689_AD75_D3455DCBED9F__INCLUDED_)
