//
//****************************************
//**  Copyright  (C)  W.ch  2001-2019   **
//**  Web:  http://www.winchiphead.com  **
//****************************************
//**  DLL for CH9344                    **
//**  C, VC6.0                          **
//****************************************
//
// CH934XGPIOӦòӿڿ      V1.0
// Ͼߺ΢ӹɷ޹˾  : zyw@wch.cn 2019.12
// 
// 
#ifndef		_CH934XGPIO_DLL_H
#define		_CH934XGPIO_DLL_H

#ifdef __cplusplus
extern "C" {
#endif

/**
 * @brief   ȡоƬ汾ţĿǰֵܵ:0x350x36.
 *
 * @param   hDev  - ͨCreateFile򿪵Ĵھֵ
 * @param   pData - صCH9344оƬ汾.
 *
 * @return  ɹTUREʧܷFALSE.
 */
BOOL WINAPI CH934XGetChipVer(HANDLE hDev,PUSHORT pData);

/**
 * @brief   ȡǰڵţ0ʼ.
 *
 * @param   hDev  - ͨCreateFile򿪵Ĵھֵ
 * @param   pData - صĴţ0ʼCH93443.
 *
 * @return  ɹTUREʧܷFALSE.
 */
BOOL WINAPI CH934XGetUartIndex(HANDLE hDev,PUSHORT pData);

/**
 * @brief   ǰڵͨģʽϵʱĬģʽ.
 *
 * @param   hDev      - ͨCreateFile򿪵Ĵھֵ.
 * @param   UartIndex - ָĴţΧֵ:0~3,ӦUart0,Uart1,Uart2,Uart3.
 * @param   ErrorCode - صĴ룬ںFALSEЧ.
 *
 * @return  ɹTUREʧܷFALSE.
 */
BOOL WINAPI CH934XEnableNormal(HANDLE hDev,USHORT UartIndex,PUCHAR ErrorCode);

/**
 * @brief   ָڵGPIOģʽ.
 *
 * @param   hDev      - ͨCreateFile򿪵Ĵھֵ.
 * @param   UartIndex - ָĴţΧֵ:0~3,ӦUart0,Uart1,Uart2,Uart3.
 * @param   Mode      - ָĴڵĹģʽΧֵ:0~3,0Ӧͨģʽ1ӦRS4852ӦGPIO3ӦӲ.
 * @param   ErrorCode - صĴ룬ںFALSEЧ.
 *                      ErrorCode=4ʱ,ʾָǹӲģʽ¡
 *
 * @return  ɹTUREʧܷFALSE.
 */
BOOL WINAPI CH934XGetCurrentMode(HANDLE hDev,USHORT UartIndex,PUCHAR Mode,PUCHAR ErrorCode);
/**
 * @brief   ָڵGPIOģʽ.
 *
 * @param   hDev      - ͨCreateFile򿪵Ĵھֵ.
 * @param   UartIndex - ָĴţΧֵ:0~3,ӦUart0,Uart1,Uart2,Uart3.
 * @param   ErrorCode - صĴ룬ںFALSEЧ.
 *                      ErrorCode=4ʱ,ʾָǹӲģʽ¡
 *
 * @return  ɹTUREʧܷFALSE.
 */
BOOL WINAPI CH934XEnableGPIO(HANDLE hDev,USHORT UartIndex,PUCHAR ErrorCode);
/**
 * @brief   ȡָGPIOķ.
 *
 * @param   hDev      - ͨCreateFile򿪵Ĵھֵ.
 * @param   UartIndex - ָĴţΧֵ:0~3,ӦUart0,Uart1,Uart2,Uart3.
 * @param   dir       - ȡGPIOķBIT0ӦGPIO0BIT1ӦGPIO1BIT2ӦGPIO20룬1.
 * @param   ErrorCode - صĴ룬ںFALSEЧ.
 *                      ErrorCode=4ʱʾָڲGPIOģʽ¡
 *
 * @return  ɹTUREʧܷFALSE.
 */
BOOL WINAPI CH934XGetGPIODir(HANDLE hDev,USHORT UartIndex,PUCHAR dir,PUCHAR ErrorCode);
/**
 * @brief   ָGPIOķ.
 *
 * @param   hDev      - ͨCreateFile򿪵Ĵھֵ.
 * @param   UartIndex - ָĴţΧֵ:0~3,ӦUart0,Uart1,Uart2,Uart3.
 * @param   GPIOIndex - ָGPIOţΧֵ:0~2,ӦGPIO0,GPIO1,GPIO2.
 * @param   dir       - ָGPIOķ0룬1.
 * @param   ErrorCode - صĴ룬ںFALSEЧ.
 *                      ErrorCode=4ʱʾָڲGPIOģʽ¡
 *
 * @return  ɹTUREʧܷFALSE.
 */
BOOL WINAPI CH934XSetGPIODir(HANDLE hDev,USHORT UartIndex,UCHAR GPIOIndex,UCHAR dir,PUCHAR ErrorCode);
/**
 * @brief   ָڵGPIOֵ.
 *
 * @param   hDev      - ͨCreateFile򿪵Ĵھֵ.
 * @param   UartIndex - ָĴţΧֵ:0~3,ӦUart0,Uart1,Uart2,Uart3.
 * @param   GPIOIndex - ָGPIOţΧֵ:0~2,ӦGPIO0,GPIO1,GPIO2.
 * @param   PinData   - ָGPIOֵ0͵ƽ1ߵƽ.
 * @param   ErrorCode - صĴ룬ںFALSEЧ.
 *                      ErrorCode=4ʱʾָڲGPIOģʽ¡
 *                      ErrorCode=6ʱʾָڷOutputģʽ¡
 *	
 * @return  ɹTUREʧܷFALSE.
 */
BOOL WINAPI CH934XSetGPIOOutput(HANDLE hDev,USHORT UartIndex,UCHAR GPIOIndex,UCHAR PinData,PUCHAR ErrorCode);
/**
 * @brief   ȡָڵGPIOֵ.
 *
 * @param   hDev      - ͨCreateFile򿪵Ĵھֵ.
 * @param   UartIndex - ָĴţΧֵ:0~3,ӦUart0,Uart1,Uart2,Uart3.
 * @param   GPIOIndex - ָGPIOţΧֵ:0~2,ӦGPIO0,GPIO1,GPIO2.
 * @param   pPinData  - GPIOֵ0͵ƽ1ߵƽ.
 * @param   ErrorCode - صĴ룬ںFALSEЧ.
 *                      ErrorCode=4ʱʾָڲGPIOģʽ¡
 *                      ErrorCode=6ʱʾָڷInputģʽ¡
 *	
 * @return  ɹTUREʧܷFALSE.
 */
BOOL WINAPI CH934XGetGPIOInput(HANDLE hDev,USHORT UartIndex,UCHAR GPIOIndex,PUCHAR pPinData,PUCHAR ErrorCode);
#ifdef __cplusplus
}
#endif

#endif		// _CH934XGPIO_DLL_H
